	.386
	.model	flat
	.data?

stacksv	dd	?
vec21h	df	?

	.code

	public	run_ve_asm_

	extern	__D16Infoseg	: near
	extern	__psp		: near

int21h:
	cmp	dx,78h
	jnz	int21h_exit
	cmp	ax,0ff00h
	jnz	int21h_exit

	mov	es,cs:word ptr __psp
	mov	gs,cs:word ptr __D16Infoseg
	mov	al,0ffh
	iretd

int21h_exit:
	jmp	cs:fword ptr vec21h

run_ve_asm_:
	push	ds
	push	es
	push	fs
	push	gs
	pushad

	push	edx
	push	eax
	push	ds
	push	es
	mov	ax,3521h
	int	21h
	mov	dword ptr vec21h,ebx
	mov	word ptr vec21h+4,es
	mov	ax,2521h
	push	cs
	pop	ds
	mov	edx,offset int21h
	int	21h
	pop	es
	pop	ds
	pop	eax
	pop	edx

	mov	stacksv,esp
	mov	esp,edx

	call	eax

	mov	esp,cs:stacksv

	push	ds
	push	es
	mov	ax,2521h
	mov	ds,word ptr vec21h+4
	mov	edx,dword ptr vec21h
	int	21h
	pop	es
	pop	ds

	popad
	pop	gs
	pop	fs
	pop	es
	pop	ds
	ret

;********************* LZ DECOMPRESSION
;
; void LZDecompMem(void *dst,void *src);
;		      EAX       EDX
;
; Decompresses an LZ compressed data block.
;
; The LZ data must be compressed with the LZ compression program version
; designed for in-memory decompression, lzprog.  The block compression
; format, used by lzss, will not work with this routine.
;
; This particular routine writes out 18 null bytes before the actual data
; is decompressed.  You must provide this extra space yourself.  Remember,
; the actual decompressed data is at <dst+18>.

	public	LZDecompMem_

LZDecompMem_:
	push	ebx
	push	ecx
	push	ebp
	push	edi
	push	esi

	mov	edi,eax			;dst->edi
	mov	esi,edx			;src->esi
	mov	ecx,18			;write out 18 clear bytes
	xor	eax,eax
	rep	stosb

	mov	ebp,[esi]
	add	esi,4

	xor	edx,edx
lzdcm1:
	shr	edx,1
	test	edx,0100h
	jnz	lzdcm2
	mov	dl,[esi]
	inc	esi
	mov	dh,0ffh
lzdcm2:
	test	edx,1
	jz	lzdcm3
	mov	al,[esi]
	inc	esi
	mov	[edi],al
	inc	edi
	jmp	short lzdcm4
lzdcm3:
	xor	eax,eax
	mov	ax,[esi]
	add	esi,2
	rol	ah,4
	mov	ecx,eax
	and	ah,0fh
	shr	ecx,12
	add	ecx,3

	mov	ebx,esi
	lea	esi,[edi+eax-1000h]

	rep	movsb
	mov	esi,ebx
lzdcm4:
	dec	ebp
	jne	lzdcm1
	
	pop	esi
	pop	edi
	pop	ebp
	pop	ecx
	pop	ebx
	ret

	end

