#ifndef	A_VEXE_H
#define	A_VEXE_H

#include <a/types.h>

#define VEXE_ID	'EV'
#define	VEXE_VERSION	(0)

#define	VEXE_COMP_NONE		(0)
#define	VEXE_COMP_LZSS		(1)
#define	VEXE_COMP_LZH		(2)

#define	VEXE_RELOC_END		(0)
#define	VEXE_RELOC_32BIT	(1)
#define	VEXE_RELOC_16BIT	(2)
#define	VEXE_RELOC_48BIT	(3)

struct VExeHeader {
	ushort	ID;
	ushort	version;
	ulong	image_offset;
	ulong	relocs_offset;
	ulong	library_offset;
	ulong	export_offset;
	ulong	image_length;
	ulong	relocs_length;
	ulong	library_length;
	ulong	export_length;
	ulong	uc_image_length;
	ulong	uc_relocs_length;
	ulong	bss_length;
	ulong	flags;
	ulong	entry_point;
	ulong	stack_point;
	ulong	resource_offset;
	uchar	image_comp;
	uchar	relocs_comp;
	uchar	library_comp;
	uchar	export_comp;
};

#endif
